local BrokenIslesPathfinder = 233368
local origGetMountDB = GoGo_GetMountDB
local origZoneCheck = GoGo_ZoneCheck

local MountTypeFlags = {
  -- Ground mounts
  [230] = { [38] = true, [330]=true, [400]=true, [402]=true, [405]=true, [701]=true, [10001]=67, [10002]=160, [10004]=67 },
  -- Riding/sea turtle
  [231] = { [15] = true, [39] = true, [402]=true, [404]=true, [10001]=108, [10002]=100, [10004]=108 },
  -- Vashj'ir Seahorse
  [232] = { [36] = true, [53] = true, [401] = true, [10001]=371, [10004]=371 },
  -- AQ-only bugs
  [241] = { [38] = true, [201] = true, [330]=true, [402]=true, [10002]=160 },
  -- Red Flying Cloud
  [247] = { [9] = true, [38] = true, [300]=true, [301]=true, [330]=true, [400]=true, [402]=true, [403]=true, [405]=true, [701]=true, [10001]=67, [10002]=160, [10003]=250, [10004]=67 },
  -- Flying Mounts
  [248] = { [9] = true, [38] = true, [300]=true, [301]=true, [330]=true, [400]=true, [402]=true, [403]=true, [405]=true, [701]=true, [10001]=67, [10002]=160, [10003]=250, [10004]=67  },
  -- Swimming mounts
  [254] = { [36] = true, [53] = true, [404] = true, [10001]=108, [10004]=108 },
  -- Water striders
  [269] = { [38] = true, [330]=true, [400]=true, [402]=true, [405]=true, [701]=true, [10001]=67, [10002]=160, [10004]=200  },
  -- chauffer mounts
  [284] = { [38] = true, [330]=true, [400]=true, [402]=true, [405]=true, [701]=true, [10001]=67, [10002]=160, [10004]=67 },
  -- 242 for Swift Spectral Gryphon (hidden in the mount journal, used while dead in certain zones) not a mountable mount
}

local ExtraMounts = {
  -- Specific mounts that don't fit the general template go here
}

GoGo_GetMountDB = function()
  origGetMountDB()
  for k,v in pairs(ExtraMounts) do
      GoGo_Variables.MountDB[k] = v
  end
  local spellID, mountType
  for _,mountID in ipairs(C_MountJournal.GetMountIDs()) do
    spellID = select(2, C_MountJournal.GetMountInfoByID(mountID))
    mountType = select(5, C_MountJournal.GetMountInfoExtraByID(mountID))
    if GoGo_Variables.MountDB[spellID] == nil and mountType ~= 242 then
      if  MountTypeFlags[mountType] == nil then
        GoGo_Msg(UnknownMount)
      else
        GoGo_Variables.MountDB[spellID] = MountTypeFlags[mountType]
      end
    end
  end
end

local function SaveContinent()
  GoGo_Variables.Player.ContinentID = GetCurrentMapContinent()
end

hooksecurefunc('SetMapToCurrentZone', SaveContinent)


GoGo_ZoneCheck = function ()
  origZoneCheck()
  if GoGo_Variables.Player.ContinentID == 8 then
    if GoGo_InBook(BrokenIslesPathfinder) then
      GoGo_Variables.ZoneExclude.CanFly = true
    end
  end
end

